function[iunit,accel,velox,dis]=DSS_waveform_reconstruct(tt,acceleration,rf)
%
 clear THM; 
 clear aaa;
 clear amp;
 clear amp_original;
 clear ddd;
 clear delay;
 clear dis;
 clear duration;
 clear error;
 clear f;
 clear fl;
 clear fmax;
 clear freq;
 clear fu;
 clear iunit;
 clear mm;
 clear nfr;
 clear nhs;
 clear nt;
 clear num2;
 clear out1;
 clear p;
 clear residual;
 clear sd;
 clear sr;
 clear t;
 clear tp;
 clear tpi; 
 clear velox;
 clear vlast;
 clear vvv;
 clear x1r;
 clear x2r;
 clear x3r;
 clear x4r;
 clear y;
 clear ffmax;
 clear ffmin;
%
MAX=50000;
MAXP=1000;
%
tp=2.*pi;
tpi=tp;
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% disp(' ');
% disp(' Enter acceleration unit:   1= G   2= m/sec^2 ');
% iunit=input(' ');
  iunit=1;
%
if(iunit==1)
    iscale=386.;
else
    iscale=1.;
end
%
t=double(tt);
y=double(acceleration);
amp=y;
amp_original=y;
%
ffmin=min(rf);
ffmax=max(rf);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
ik=0;
%      
x1r=zeros(MAXP,1);	
x2r=zeros(MAXP,1);	
x3r=zeros(MAXP,1);	
x4r=zeros(MAXP,1);	
%
nfr=100;
%
if(nfr>MAXP)
    nfr=MAXP;
end
%		   
fmax=0.;
%
residual=y;
%
num2=max(size(y));
%
clear y;
%		
duration=t(num2)-t(1);
%
sr=duration/(num2-1);
sr=1./sr;
%
% out1=sprintf(' sample rate = %10.4g \n',sr);
% disp(out1);
%
fl=3./duration;
fu=sr/5.;
tp=2*pi;
%
stdr=std(residual);
clear y;
clear length;
%
errormax=0;
%
for(i=1:length(residual))
    errormax=errormax+(residual(i))^2;
end
%
ie=1;
disp(' ');
for(ijk=1:10000)
%    
    ran1=rand;
    ran2=rand;	
    ran3=rand;
%				
    x1=rand;
    x2=rand;
    x33=rand;
    x4=rand;
%
    amn=std(residual);
    x1=amn*(x1-0.5)*rand;		% amplitude
    x2=((ffmax-ffmin)*rand + ffmin)*tp;	% freq    
    x3= 3+(2*round(x33*30));	% nhs
    x4=x4*0.6*duration;		% delay
%
    while(1)
%
	    if( tp*x3/(2.*x2) + x4 < duration )
			break;
		else
			x3=x3-2;
            if(x3==3)
                x4=0;
                break;
            end
        end
    end   
%
    error=0.;
%
    t1=x4 + t(1);
    t2=t1 + tp*x3/(2.*x2);
%
    fmin=duration/1.75;
    if(fmin<ffmin)
        fmin=ffmin;
    end
%
	if(j==1)
	   x1=0;
	   x2=fu*tp;
	   x3=3;
	   x4=0;
    end
%
    if(x3>=3 && x3 <=201)
    else
        x3=3;
        x4=0;
    end
%
    error=0;
%
	for(i=1:num2)
%		
		    tt=t(i);
%
			y=0.;
%
		    if( tt>= t1 && tt <= t2)
%				
			    arg=x2*(tt-t1);  
%
				y=x1*sin(arg/double(x3))*sin(arg);
%
				error=error+((residual(i)-y)^2);
%
			else
			    error=error+residual(i);
            end
    end          
%            
    error=sqrt(error);
%
    if(error<errormax && x2>=(fmin*tp) && x3>=3  && abs(x1)>1.0e-30)
%
				x1r(ie)=x1;
				x2r(ie)=x2;
				x3r(ie)=x3;
				x4r(ie)=x4;
                ie=ie+1;
%
				out1=sprintf(' %d  %11.4e  %9.4f  %9.4f  %d  %9.4f ',ie-1,error,x1,x2/tp,x3,x4);
                disp(out1);
%
				errormax=error;
                residual=residual-y;
%
    end
%
end    
nfr=ie-1;
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
clear aaa;
clear vvv;
clear ddd;
clear mm;
%
aaa=zeros(num2,1); 
vvv=zeros(num2,1); 
ddd=zeros(num2,1); 
%
		disp(' ');
%
		kk=0;
%
		for(i=1:nfr)
%
            if(x2r(i)<ffmin*tp)
                x2r(i)=ffmin*tp;
                x1r(i)=1.0e-20;
                x3r(i)=3;
                x4r(i)=0;
            end
%
%%			out1=sprintf(' amp=%10.4f   freq=%10.3f Hz   nhs=%d   delay=%10.4f ',x1r(i),x2r(i)/tp,x3r(i),x4r(i));
%%            disp(out1);
%
            wavelet_table(i,1)=i;
            wavelet_table(i,2)=x2r(i)/tpi;           
            wavelet_table(i,3)=x1r(i);
            wavelet_table(i,4)=x3r(i); 
            wavelet_table(i,5)=x4r(i);              
%
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		tf=0.;
%
		vlast=zeros(num2,1);
%
%%        num2
%%        nfr
%%        iscale
		for(k=1:num2)
%
				tt=t(k);
%              
				for(jj=1:nfr)
%				
                    w=0.;
					v=0.;
					d=0.;
%
					v1=0.;
					v2=0.;
%
					d1=0.;
					d2=0.;
%
					t1=x4r(jj)+t(1);
%
                    if(x2r(jj)>=1.0e-10)
%
                    else
                        x2r(jj)=ffmin*tp;
                        x1r(jj)=1.0e-20;
                        x3r(jj)=3;
                        x4r(jj)=0;
                        t1=x4r(jj)+t(1);  
                    end    
                    t2=tp*x3r(jj)/(2.*x2r(jj))+t1; 
%
					if( tt>=t1  && tt <=t2 && x3r(jj)>=3 )
%					
						arg=x2r(jj)*(tt-t1);  
%
						w=  x1r(jj)*sin(arg/double(x3r(jj)))*sin(arg);
%
                        aa=x2r(jj)/double(x3r(jj));
						bb=x2r(jj);
%
						alpha1=aa+bb;
					    alpha2=aa-bb;
%
						te=tt-t1;
%
						v1= -sin(alpha1*tf)/(2.*alpha1) + sin(alpha2*tf)/(2.*alpha2);
				        v2= -sin(alpha1*te)/(2.*alpha1) + sin(alpha2*te)/(2.*alpha2);
%
                        d1=  cos(alpha1*tf)/(2.*(alpha1^2)) - cos(alpha2*tf)/(2.*(alpha2^2));
                        d2=  cos(alpha1*te)/(2.*(alpha1^2)) - cos(alpha2*te)/(2.*(alpha2^2));
%
						v=(v2-v1)*iscale*x1r(jj);
						d=(d2-d1)*iscale*x1r(jj);
%
						vlast(jj)=v;
%
                    end
%
					aaa(k)=aaa(k)+w; 
					vvv(k)=vvv(k)+v;
					ddd(k)=ddd(k)+d;
%
					amp(k)=amp(k)-w;
%
					if(x3r(jj)<1)
                        printf(' error x3r ');
                        break;
                    end
%
                end
%
%%               out1=sprintf(' %d t=%8.4g  %8.4g  %8.4g  %8.4g ',k,t(k),aaa(k),vvv(k),ddd(k));
%%               disp(out1);
        end
%%
        sz=size(t);
        if(sz(2)>sz(1))
            t=t';
        end
        sz=size(amp);
        if(sz(2)>sz(1))
            amp=amp';
        end    
        sz=size(aaa);
        if(sz(2)>sz(1))
            aaa=aaa';
        end          
        error=[t,amp];
        accel=[t,aaa];
        velox=[t,vvv];
        dis  =[t,ddd];
%
end